> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.nvidia.com/nemo-platform/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.nvidia.com/nemo-platform/_mcp/server.

# Upload Fileset Content

PUT /apis/files/v2/workspaces/{workspace}/filesets/{name}/-/{path}
Content-Type: application/octet-stream

Upload file content to a fileset.

Reference: https://docs.nvidia.com/nemo-platform/documentation/reference/api-reference/files/upload-file-apis-files-v-2-workspaces-workspace-filesets-name-path-put

## Request

### Path parameters

- `workspace` (string, required)
- `name` (string, required)
- `path` (string, required)

### Body (application/octet-stream)

- Binary request body.

## Response

### 200

Successful Response

- `file_ref` (string, required)
- `file_url` (string, required)
- `path` (string, required)
- `size` (integer, required)
- `cache_status` (enum, optional) — Cache status for files in external storage backends.
  - Allowed values: `cached`, `caching`, `not_cached`, `not_cacheable`

## Examples

**Request**

```json
"VGhpcyBpcyBhIHRlc3QgZmlsZSBjb250ZW50Lg=="
```

**Response**

```json
{
  "file_ref": "abc123def456ghi789",
  "file_url": "https://nemo-platform.example.com/files/workspace123/filesetA/-/documents/report.pdf",
  "path": "documents/report.pdf",
  "size": 24576,
  "cache_status": "cached"
}
```

**SDK Code**

```python
import requests

url = "https://api.example.com/apis/files/v2/workspaces/workspace/filesets/name/-/path"

payload = "\"VGhpcyBpcyBhIHRlc3QgZmlsZSBjb250ZW50Lg==\""
headers = {"Content-Type": "application/octet-stream"}

response = requests.put(url, data=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.example.com/apis/files/v2/workspaces/workspace/filesets/name/-/path';
const options = {
  method: 'PUT',
  headers: {'Content-Type': 'application/octet-stream'},
  body: '"VGhpcyBpcyBhIHRlc3QgZmlsZSBjb250ZW50Lg=="'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.example.com/apis/files/v2/workspaces/workspace/filesets/name/-/path"

	payload := strings.NewReader("\"VGhpcyBpcyBhIHRlc3QgZmlsZSBjb250ZW50Lg==\"")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("Content-Type", "application/octet-stream")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.example.com/apis/files/v2/workspaces/workspace/filesets/name/-/path")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["Content-Type"] = 'application/octet-stream'
request.body = "\"VGhpcyBpcyBhIHRlc3QgZmlsZSBjb250ZW50Lg==\""

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://api.example.com/apis/files/v2/workspaces/workspace/filesets/name/-/path")
  .header("Content-Type", "application/octet-stream")
  .body("\"VGhpcyBpcyBhIHRlc3QgZmlsZSBjb250ZW50Lg==\"")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://api.example.com/apis/files/v2/workspaces/workspace/filesets/name/-/path', [
  'body' => '"VGhpcyBpcyBhIHRlc3QgZmlsZSBjb250ZW50Lg=="',
  'headers' => [
    'Content-Type' => 'application/octet-stream',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.example.com/apis/files/v2/workspaces/workspace/filesets/name/-/path");
var request = new RestRequest(Method.PUT);
request.AddHeader("Content-Type", "application/octet-stream");
request.AddParameter("application/octet-stream", "\"VGhpcyBpcyBhIHRlc3QgZmlsZSBjb250ZW50Lg==\"", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Content-Type": "application/octet-stream"]

let postData = NSData(data: ""VGhpcyBpcyBhIHRlc3QgZmlsZSBjb250ZW50Lg=="".data(using: String.Encoding.utf8)!)

let request = NSMutableURLRequest(url: NSURL(string: "https://api.example.com/apis/files/v2/workspaces/workspace/filesets/name/-/path")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```